#include "Stdafx.h"

#define WIN_TOOLS_PATH  L"\\\\10.4.0.102\\MSWG2\\download\\win-tools\\"
#define PYTHON_PATH     L"\\\\10.4.0.102\\mswg\\win\\Packages\\Regression\\python_install\\"
#define REGRESSION_PATH L"\\\\10.4.0.102\\mswg\\win\\Packages\\Regression\\"


CInstall::CInstall(MachineArch Arch, OsVersion OsVer)
{
    m_Arch = Arch;
    m_OsVer = OsVer;
}

bool
CInstall::DoInstall()
{
    bool bRet;
   
    wprintf(L"===>UnixTools\n");    
    bRet = UnixTools();
    if(bRet == false)
    {
        return false;
    }
    
    wprintf(L"===>7Zip\n");         
    bRet = Zip();
    if(bRet == false)
    {
        return false;
    }

    wprintf(L"===>DbgView\n");
    bRet = DbgView();
    if(bRet == false)
    {
        return false;
    }

    wprintf(L"===>Gvim\n");
    bRet = Gvim();
    if(bRet == false)
    {
        return false;
    }

    wprintf(L"===>svn\n");
    bRet = svn();
    if(bRet == false)
    {
        return false;
    }

    wprintf(L"===>putty\n");
    bRet = putty();
    if(bRet == false)
    {
        return false;
    }
    
    wprintf(L"===>ActiceTcl\n");
    bRet = ActiceTcl();
    if(bRet == false)
    {
        return false;
    }

    wprintf(L"===>SourceInsight\n");
    bRet = SourceInsight();
    if(bRet == false)
    {
        return false;
    }
                   
    wprintf(L"===>WireShark\n");    
    bRet = WireShark();
    if(bRet == false)
    {
        return false;
    }

    wprintf(L"===>WDK\n");
    bRet = WDK();
    if(bRet == false)
    {
        return false;
    }

    wprintf(L"===>SDK\n");
    bRet = SDK();
    if(bRet == false)
    {
        return false;
    }   
    
    wprintf(L"===>WSD_hotfix\n");    
    bRet = WSD_hotfix();
    if(bRet == false)
    {
        return false;
    }

    
    wprintf(L"===>Python\n");        
    bRet = Python();
    if(bRet == false)
    {
        return false;
    }
    
    wprintf(L"===>Cpy Python Lib\n");
    bRet = CpyPythonLib();
    if(bRet == false)
    {
        return false;
    }
    
    wprintf(L"===>PythonExtention\n");
    bRet = PythonExtention();
    if(bRet == false)
    {
        return false;
    }
    
    wprintf(L"===>WMI Running Setup.py install\n");
    bRet = WMI();
    if(bRet == false)
    {
        return false;
    }
   
    wprintf(L"===>MakeSDK_ShortCUt\n");
    bRet = MakeSDK_ShortCUt();
    if(bRet == false)
    {
        return false;
    }
    

    wprintf(L"===>VistaBoot\n");
    bRet = VistaBoot();
    if(bRet == false)
    {
        return false;
    }
       
    return true;
}

//
//
//
bool
CInstall::UnixTools()
{
    int retVal;
    
    CComBSTR bstrUnitToolsPath = WIN_TOOLS_PATH;
    bstrUnitToolsPath += L"UnixTools";

    CComBSTR bstrCmd = L"start cmd /c xcopy /s /i /Y ";
    bstrCmd += bstrUnitToolsPath;
    if(m_OsVer == Win2003)
    {
        bstrCmd += L" c:\\UnixTools";
    }
    else
    {
        bstrCmd += L" d:\\UnixTools";
    }
            
    retVal = _wsystem(bstrCmd);    
    if(retVal == -1)
    {
        wprintf(L"Error in executing command: %s\n",bstrCmd);        
        return false;
    }
    

    if(m_OsVer == Win2003)
    {
        bstrCmd = L"start cmd /c \\\\tzachid0\\q$\\downloads\\setx.exe path \"%path%;c:\\UnixTools\" -m set path=%path%;c:\\UnixTools";        
    }
    else
    {
        bstrCmd = L"start cmd /c \\\\tzachid0\\q$\\downloads\\setx.exe path \"%path%;d:\\UnixTools\" -m set path=%path%;d:\\UnixTools";
    }
    
    //
    //  Add UnixTools To path
    retVal = _wsystem(bstrCmd);
    if(retVal == -1)
    {
        wprintf(L"Error in executing command: %s\n",bstrCmd);        
        return false;
    }

        

    return true;
}


//
//
//
bool
CInstall::Zip()
{    
    int retVal;
    
    CComBSTR ZipExePath = REGRESSION_PATH;       
    ZipExePath += L"7z313.exe";
        
    CComBSTR bstrCmd = ZipExePath;
    bstrCmd += L" /Q";
    //
    //  Install 7zip
    retVal = _wsystem(bstrCmd);
    if(retVal == -1)
    {
        wprintf(L"Error in executing command: %s\n",bstrCmd);        
        return false;
    }

        
    return true;        
}



//
//
//
bool
CInstall::DbgView()
{    
    int retVal;
    CComBSTR bstrDbgPath= WIN_TOOLS_PATH;
    bstrDbgPath += L"DebugView\\";

    CComBSTR bstrMsiPath = bstrDbgPath;
    bstrMsiPath += L"Dbgview.exe";

    CComBSTR bstrCmd = L"xcopy /y  ";
    bstrCmd += bstrMsiPath;    
    bstrCmd += L" \"%USERPROFILE%\\Desktop\" ";
   
    retVal = _wsystem(bstrCmd);
    if(retVal == -1)
    {
        wprintf(L"Error in executing command: %s\n",bstrCmd);        
        return false;
    }

    bstrCmd = L"REGEDIT ";
    bstrCmd += bstrDbgPath;
    bstrCmd += L"debugview.reg";
        
    retVal = _wsystem(bstrCmd);
    if(retVal == -1)
    {
        wprintf(L"Error in executing command: %s\n",bstrCmd);        
        return false;
    }
    
    return true;
}

//
//
//
bool
CInstall::Gvim()
{
    int retVal;
    CComBSTR bstrDbgPath= WIN_TOOLS_PATH;

    CComBSTR bstrMsiPath = bstrDbgPath;
    bstrMsiPath += L"gvim72.exe";
    
    CComBSTR bstrCmd = bstrMsiPath;

    retVal = _wsystem(bstrCmd);
    if(retVal == -1)
    {
        wprintf(L"Error in executing command: %s\n",bstrCmd);        
        return false;
    }

    bstrCmd = L"xcopy /y  ";
    bstrCmd += WIN_TOOLS_PATH;
    bstrCmd += L"_vimrc";     
    if(m_Arch == x64)
    {
        bstrCmd += L" \"%HOMEDRIVE%\\Program Files (x86)\\Vim\\\"";    
    }
    else
    {
        bstrCmd += L" \"%HOMEDRIVE%\\Program Files\\Vim\\\"";
    }
    

    retVal = _wsystem(bstrCmd);
    if(retVal == -1)
    {
        wprintf(L"Error in executing command: %s\n",bstrCmd);        
        return false;
    }
       

    
    
    return true;
    
}

//
//
//
bool
CInstall::svn()
{
    int retVal;
    CComBSTR bstrDbgPath= WIN_TOOLS_PATH;
    bstrDbgPath += L"svn\\";

    CComBSTR bstrMsiPath = bstrDbgPath;
    bstrMsiPath += L"svn-1.4.2-setup.exe";

    
    CComBSTR bstrCmd = bstrMsiPath;


    retVal = _wsystem(bstrCmd);
    if(retVal == -1)
    {
        wprintf(L"Error in executing command: %s\n",bstrCmd);        
        return false;
    }
    
    return true;
}

//
//
//
bool
CInstall::putty()
{
    int retVal;
    CComBSTR bstrDbgPath= WIN_TOOLS_PATH;

    CComBSTR bstrMsiPath = bstrDbgPath;
    bstrMsiPath += L"putty.exe";

    
    CComBSTR bstrCmd = L"xcopy /y  ";
    bstrCmd += bstrMsiPath;
    bstrCmd += L" \"%USERPROFILE%\\Desktop\" ";
  
    retVal = _wsystem(bstrCmd);
    if(retVal == -1)
    {
        wprintf(L"Error in executing command: %s\n",bstrCmd);        
        return false;
    }
    
    return true;
}

//
//
//
bool
CInstall::WMI()
{
   int retVal;
    CComBSTR bstrPythonPath= PYTHON_PATH;

    
    CComBSTR bstrSetupInstall = bstrPythonPath;
    bstrSetupInstall += L"WMI\\";

    CComBSTR bstrCmd  = bstrSetupInstall;
    bstrCmd += L"setup.py install" ;
    
    //
    //  Run Setup.py
    retVal = _wsystem(bstrCmd);
    if(retVal == -1)
    {
        wprintf(L"Error in executing command: %s\n",bstrCmd);        
        return false;
    }
    
    return true;      
}

//
//
//
bool
CInstall::ActiceTcl()
{
    int retVal;
    CComBSTR bstrDbgPath= WIN_TOOLS_PATH;
    bstrDbgPath += L"TCL8~1.4\\";

    CComBSTR bstrMsiPath = bstrDbgPath;
    bstrMsiPath += L"ActiveTcl8.4.13.0.261555-win32-ix86-threaded.exe";

    
    CComBSTR bstrCmd = bstrMsiPath;

    retVal = _wsystem(bstrCmd);
    if(retVal == -1)
    {
        wprintf(L"Error in executing command: %s\n",bstrCmd);        
        return false;
    }
    
    return true;
}

//
//
//
bool
CInstall::SourceInsight()
{
    int retVal;
    CComBSTR bstrDbgPath= WIN_TOOLS_PATH;
    bstrDbgPath += L"SourceInsight\\";

    CComBSTR bstrMsiPath = bstrDbgPath;
    bstrMsiPath += L"Si3554Setup.exe";

    
    CComBSTR bstrCmd = bstrMsiPath;


    retVal = _wsystem(bstrCmd);
    if(retVal == -1)
    {
        wprintf(L"Error in executing command: %s\n",bstrCmd);        
        return false;
    }
    
    return true;
}

//
bool
CInstall::CpyPythonLib()
{
    if(m_OsVer == Win2008 && m_Arch == x64)
    {
        int retVal;
        
        CComBSTR bstrCmd = L"xcopy /s /i /Y ";
        bstrCmd += L" C:\\Python24\\Lib\\site-packages\\pywin32_system32";

        bstrCmd += L" %SystemRoot%\\system32";
        
        retVal = _wsystem(bstrCmd);
        if(retVal == -1)
        {
            wprintf(L"Error in executing command: %s\n",bstrCmd);        
            return false;
        }

        
        bstrCmd  = L"xcopy /s /i /Y ";
        bstrCmd += L" C:\\Python24\\Lib\\site-packages\\pywin32_system32";

        bstrCmd += L" %SystemRoot%\\SysWOW64";
        retVal = _wsystem(bstrCmd);
        if(retVal == -1)
        {
            wprintf(L"Error in executing command: %s\n",bstrCmd);        
            return false;
        }
        
    }

    return true;
}

//
//
//
bool
CInstall::WDK()
{
    int retVal;
    CComBSTR bstrDbgPath= WIN_TOOLS_PATH;
    bstrDbgPath += L"wdk\\6001.18001\\";

    CComBSTR bstrMsiPath = bstrDbgPath;
    bstrMsiPath += L"Installer.exe";

    
    CComBSTR bstrCmd = bstrMsiPath;

    retVal = _wsystem(bstrCmd);
    if(retVal == -1)
    {
        wprintf(L"Error in executing command: %s\n",bstrCmd);        
        return false;
    }
    
    return true;
}

//
//
//
bool
CInstall::SDK()
{
    int retVal;
    CComBSTR bstrDbgPath= WIN_TOOLS_PATH;
    bstrDbgPath += L"SDK_2008_6_01\\6.0.6001.18000.367-KRMSDK_EN\\";

    CComBSTR bstrMsiPath = bstrDbgPath;
    bstrMsiPath += L"Setup.Exe";

    
    CComBSTR bstrCmd = bstrMsiPath;


    retVal = _wsystem(bstrCmd);
    if(retVal == -1)
    {
        wprintf(L"Error in executing command: %s\n",bstrCmd);        
        return false;
    }
             
    return true;
}

bool
CInstall::WSD_hotfix()
{
    
    if(m_OsVer == Win2003)
    {
        
        int retVal;
        CComBSTR bstrWSDPath= L"\"\\\\labfs01\\MSWG2\\download\\win-tools\\WSD hotfix\\";
        
        
        CComBSTR bstrExePath = bstrWSDPath;
        
        if(m_Arch == x64)
        {
            bstrExePath += L"WindowsServer2003.WindowsXP-KB927620-x64-ENU.exe\"";
        }
        else if(m_Arch == X86)
        {
            bstrExePath += L"WindowsServer2003-KB927620-x86-ENU.exe\"";
        }

        
        CComBSTR bstrCmd = bstrExePath;
        
        retVal = _wsystem(bstrCmd);
        if(retVal == -1)
        {
            wprintf(L"Error in executing command: %s\n",bstrCmd);        
            return false;
        }
        
    }
    
    return true;
    
}

bool
CInstall::WireShark()
{    
    int retVal;
    CComBSTR bstrWireSharkPath= WIN_TOOLS_PATH;
    
    CComBSTR bstrMsiPath = bstrWireSharkPath;       
    bstrMsiPath += L"wireshark\\wireshark-setup-1.0.4.exe";
        
    CComBSTR bstrCmd = bstrMsiPath;
    
    //
    //  Install Wireshrk
    retVal = _wsystem(bstrCmd);
    if(retVal == -1)
    {
        wprintf(L"Error in executing command: %s\n",bstrCmd);        
        return false;
    }


    return true;
    
}

bool
CInstall::VistaBoot()
{    
    int retVal;
    CComBSTR bstrPath= WIN_TOOLS_PATH;
    
    CComBSTR bstrMsiPath = bstrPath;       
    bstrMsiPath += L"VistaBootPRO_3.3.0.exe";
        
    CComBSTR bstrCmd = bstrMsiPath;
    
    //
    //  Install Wireshrk
    retVal = _wsystem(bstrCmd);
    if(retVal == -1)
    {
        wprintf(L"Error in executing command: %s\n",bstrCmd);        
        return false;
    }


    return true;
    
}


//
//
//
bool
CInstall::Python()
{    
    int retVal;
    CComBSTR bstrPythonPath= PYTHON_PATH;

    CComBSTR bstrMsiPath = bstrPythonPath;
    bstrMsiPath += L"python-2.4.msi";
        
    CComBSTR bstrCmd = bstrMsiPath;
    //
    //  Install Python
    retVal = _wsystem(bstrCmd);
    if(retVal == -1)
    {
        wprintf(L"Error in executing command: %s\n",bstrCmd);        
        return false;
    }
   
    return true;      
}

//
//
//
bool
CInstall::PythonExtention()
{
    int retVal;
    CComBSTR bstrPythonPath= PYTHON_PATH;

    CComBSTR bstrMsiPath = bstrPythonPath;
    bstrMsiPath += L"pywin32-203.win32-py2.4.exe";
     
    CComBSTR bstrCmd = bstrMsiPath;
    //
    //  Install Python
    retVal = _wsystem(bstrCmd);
    if(retVal == -1)
    {
        wprintf(L"Error in executing command: %s\n",bstrCmd);        
        return false;
    }        
    
    return true;      
}

//
//
//
bool
CInstall::MakeSDK_ShortCUt()
{    
    CComBSTR bstrCmd=L"start cmd /c %HOMEDRIVE%\\Python24\\python.exe \\\\labfs01\\MSWG2\\download\\win-tools\\Install_Sw_Tools\\create_SDK_path.py";    
    int retVal = _wsystem(bstrCmd);
    if(retVal == -1)
    {
        wprintf(L"Error in executing command: %s\n",bstrCmd);        
        return false;
    }
    
    return true;
}

BOOL
CInstall::Reboot()
{
    HANDLE Token;
    BOOL b;
    TOKEN_PRIVILEGES NewPrivileges;
    LUID Luid;

    //
    // we need to "turn on" reboot privilege
    // if any of this fails, try reboot anyway
    //
    if(!OpenProcessToken(GetCurrentProcess(),TOKEN_ADJUST_PRIVILEGES,&Token)) {
        goto final;
    }

    if(!LookupPrivilegeValue(NULL,SE_SHUTDOWN_NAME,&Luid)) {
        CloseHandle(Token);
        goto final;
    }

    NewPrivileges.PrivilegeCount = 1;
    NewPrivileges.Privileges[0].Luid = Luid;
    NewPrivileges.Privileges[0].Attributes = SE_PRIVILEGE_ENABLED;

    AdjustTokenPrivileges(
            Token,
            FALSE,
            &NewPrivileges,
            0,
            NULL,
            NULL
            );

    CloseHandle(Token);

final:

    //
    // attempt reboot - inform system that this is planned hardware install
    //
    return ExitWindowsEx(EWX_REBOOT, REASON_PLANNED_FLAG|REASON_HWINSTALL);
}








