#include "Stdafx.h"


bool GetMachineArch(MachineArch& Arch);
bool GetOsVersion(OsVersion& OsVer);


int __cdecl wmain( int argc, WCHAR **argv )
{
    bool bRet;
    
    MachineArch Arch;
    bRet = GetMachineArch(Arch);
    if(bRet == false)
    {
        return 0;
    }
    
    OsVersion OsVer;
    bRet = GetOsVersion(OsVer);
    if(bRet == false)
    {
        return 0;
    }

    CInstall InstallMng(Arch,OsVer);

    bRet= InstallMng.DoInstall();
    if(bRet == false)
    {
        return 0;
    }

    InstallMng.Reboot();

     return 1;    
}

//
//
//
bool GetMachineArch(MachineArch& Arch)
{    
    PGNSI pGNSI;
    SYSTEM_INFO si;
    ZeroMemory(&si, sizeof(SYSTEM_INFO));
    
    pGNSI = (PGNSI) GetProcAddress(GetModuleHandle(TEXT("kernel32.dll")), "GetNativeSystemInfo");
    if(pGNSI != NULL)
    {
        pGNSI(&si);        
    }
    else
    {
        ASSERT(FALSE);
        GetSystemInfo(&si);        
    }

    if(si.wProcessorArchitecture == PROCESSOR_ARCHITECTURE_AMD64)
    {
        wprintf(L"Arch = PROCESSOR_ARCHITECTURE_AMD64 \n");
        Arch = x64;
    }
    else if(si.wProcessorArchitecture == PROCESSOR_ARCHITECTURE_INTEL)
    {
        wprintf(L"Arch = PROCESSOR_ARCHITECTURE_INTEL \n");
        Arch = X86;
    }
    else
    {
        ASSERT(FALSE);
    }

    return true;
}

//
//
//
bool GetOsVersion(OsVersion& OsVer)
{    
    BOOL bOsVersionInfoEx;
    OSVERSIONINFOEX osvi;    
    ZeroMemory(&osvi, sizeof(OSVERSIONINFOEX));
    
    osvi.dwOSVersionInfoSize = sizeof(OSVERSIONINFOEX);
    
   
   if( !(bOsVersionInfoEx = GetVersionEx ((OSVERSIONINFO *) &osvi)) )
   {
        wprintf(L"Error in GetOsVersion function.Going to Exit\n");
        return false;
   }
  
  if ( osvi.dwMajorVersion == 6)
    {
         OsVer = Win2008;
         wprintf(L"OS version is Win2008\n");
         return true;
    }
  
    if ( osvi.dwMajorVersion == 5)
    {
         OsVer = Win2003;
         wprintf(L"OS version is Win2003 or XP \n");
         return true;
    }
  

   wprintf(L"Unknown OS going to Exit \n");
   return false;     
}
   
