#include "Stdafx.h"


bool GetMachineArch(MachineArch& Arch);
bool GetOsVersion(OsVersion& OsVer);


int __cdecl wmain( int argc, WCHAR **argv )
{
    bool bRet;
    
    MachineArch Arch;
    bRet = GetMachineArch(Arch);
    if(bRet == false)
    {
        return 0;
    }
    
    OsVersion OsVer;
    bRet = GetOsVersion(OsVer);
    if(bRet == false)
    {
        return 0;
    }

    CInstall InstallMng(Arch,OsVer);


    bRet= InstallMng.DoInstall();
    if(bRet == false)
    {
        return 0;
    }

    bRet= InstallMng.ForRegression();
    if(bRet == false)
    {
        return 0;
    }

     return 1;    
}

//
//
//
bool GetMachineArch(MachineArch& Arch)
{    
    PGNSI pGNSI;
    SYSTEM_INFO si;
    ZeroMemory(&si, sizeof(SYSTEM_INFO));
    
    pGNSI = (PGNSI) GetProcAddress(GetModuleHandle(TEXT("kernel32.dll")), "GetNativeSystemInfo");
    if(pGNSI != NULL)
    {
        pGNSI(&si);        
    }
    else
    {
        ASSERT(FALSE);
        GetSystemInfo(&si);        
    }

    if(si.wProcessorArchitecture == PROCESSOR_ARCHITECTURE_AMD64)
    {
        wprintf(L"Arch = PROCESSOR_ARCHITECTURE_AMD64 \n");
        Arch = x64;
    }
    else if(si.wProcessorArchitecture == PROCESSOR_ARCHITECTURE_INTEL)
    {
        wprintf(L"Arch = PROCESSOR_ARCHITECTURE_INTEL \n");
        Arch = X86;
    }
    else
    {
        ASSERT(FALSE);
    }

    return true;
}

//
//
//
bool GetOsVersion(OsVersion& OsVer)
{    
    BOOL bOsVersionInfoEx;
    OSVERSIONINFOEX osvi;    
    ZeroMemory(&osvi, sizeof(OSVERSIONINFOEX));
    
    osvi.dwOSVersionInfoSize = sizeof(OSVERSIONINFOEX);
    
   
   if( !(bOsVersionInfoEx = GetVersionEx ((OSVERSIONINFO *) &osvi)) )
   {
        wprintf(L"Error in GetOsVersion function.Going to Exit\n");
        return false;
   }



   if ( osvi.dwMajorVersion == 6)
   {
        OsVer = Win2008;
        wprintf(L"OS version is Win2008\n");
        return true;
   }

   if ( osvi.dwMajorVersion == 5)
   {
        OsVer = Win2003;
        wprintf(L"OS version is Win2003 or XP \n");
        return true;
   }

   wprintf(L"Unknown OS going to Exit \n");
   return false;     
}
   

/*
    CComBSTR bstrEnvVar = _wgetenv(L"PROCESSOR_ARCHITECTURE");
    bstrEnvVar.ToLower();    
    if(bstrEnvVar == L"amd64")
    {
        Arch = x64;   
    }
    else if(bstrEnvVar == L"x86")
    {
        Arch = X86;
    }
    else
    {
        ASSERT(FALSE);
    }

    return true;
    */


/*    
    FILE *pPipe =NULL;
    TCHAR buffer[BUFSIZE] ={0};


    int Length = wcslen(AMD64Buf);
    AMD64Buf[Length]= 10;
    
    Length = wcslen(X86Buf);
    X86Buf[Length]= 10;

    TCHAR AMD64Buf[BUFSIZE]=L"PROCESSOR_ARCHITECTURE=AMD64";
    TCHAR X86Buf[BUFSIZE]  =L"PROCESSOR_ARCHITECTURE=x86";

    pPipe= _wpopen(L"set PROCESSOR_ARCHITECTURE", L"rt");
    if (pPipe== NULL)
    {
        wprintf(L"popen(%s,r) faild \n",L"set PROCESSOR_ARCHITECTURE");
        return false;
    }
   
    if( fgetws(buffer, sizeof(buffer), pPipe) == NULL)    
    {
        wprintf(L"fgets error -System type -  %d\n",GetLastError() );
        return false;
    }


    if ( wcscmp(buffer,AMD64Buf) == 0 )
    {
        Arch = x64;
    }
    else if ( wcscmp(buffer,X86Buf) == 0 )
    {
        Arch = X86;
    }
    else
    {
        ASSERT(FALSE);
    }

    if(_pclose(pPipe) == -1)      // closing the pipe 
    {
        wprintf(L"ERROR Closing pipe \n");
        return false;
    }
*/


