import sys
import os
import shutil
import subprocess
import datetime

##################################
### get_username
################################## 
def get_username():

    try:
        pipe = subprocess.Popen("whoami",  stdout=subprocess.PIPE)
        rc = pipe.wait()
        if rc != 0:
            script_exit("Cmd '%s' failed, rc=%s" % (whoami, rc))
        print "=============" 
        name = pipe.stdout.readline()

    except OSError, e:    
        script_exit("Cmd '%s' failed, error=%s" % (cmd, os.strerror(e.errno)))
    return name[:-2]



##################################
### run_cmd
################################## 
def run_cmd(cmd):

    try:
        pipe = subprocess.Popen(cmd, False)
        rc = pipe.wait()
        if rc != 0:
            script_exit("Cmd '%s' failed, rc=%s" % (cmd, rc))
    except OSError, e:    
        script_exit("Cmd '%s' failed, error=%s" % (cmd, os.strerror(e.errno)))


###################
# script_exit
###################
def script_exit(err, exit_code=1):

    print err
    sys.exit(exit_code)


#################################
#           Main                
##################################
if __name__ == '__main__':


    user = get_username()

    d = datetime.date.today()

    t = datetime.datetime.now()
    time = str(t.hour) + "-" + str(t.minute)

    dir = "\\\\labfs01\\swgwork\\" + user + "\\backup\\" + d.isoformat() + "-" + time

    cmd0 = os.path.dirname (sys.argv[0]) + "\\svnbackup.cmd"
    run_cmd(cmd0)

    cmd1 = "cmd /c md " + dir

    run_cmd(cmd1)

    cmd2 = "cmd /c copy svnbackup.7z " + dir
    run_cmd(cmd2)

    print "Backup finished successfuly to directory "  + dir